Deleted Added
full compact
release.sh (282500) release.sh (282693)
1#!/bin/sh
2#-
3# Copyright (c) 2013-2015 The FreeBSD Foundation
4# Copyright (c) 2013 Glen Barber
5# Copyright (c) 2011 Nathan Whitehorn
6# All rights reserved.
7#
8# Portions of this software were developed by Glen Barber

--- 19 unchanged lines hidden (view full) ---

28# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
29# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
30# SUCH DAMAGE.
31#
32# release.sh: check out source trees, and build release components with
33# totally clean, fresh trees.
34# Based on release/generate-release.sh written by Nathan Whitehorn
35#
1#!/bin/sh
2#-
3# Copyright (c) 2013-2015 The FreeBSD Foundation
4# Copyright (c) 2013 Glen Barber
5# Copyright (c) 2011 Nathan Whitehorn
6# All rights reserved.
7#
8# Portions of this software were developed by Glen Barber

--- 19 unchanged lines hidden (view full) ---

28# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
29# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
30# SUCH DAMAGE.
31#
32# release.sh: check out source trees, and build release components with
33# totally clean, fresh trees.
34# Based on release/generate-release.sh written by Nathan Whitehorn
35#
36# $FreeBSD: head/release/release.sh 282500 2015-05-05 16:28:04Z gjb $
36# $FreeBSD: head/release/release.sh 282693 2015-05-09 21:08:12Z gjb $
37#
38
37#
38
39PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin"
40export PATH
39export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin"
41
40
41VERSION=2
42
42# Prototypes that can be redefined per-chroot or per-target.
43load_chroot_env() { }
44load_target_env() { }
45buildenv_setup() { }
46
43# Prototypes that can be redefined per-chroot or per-target.
44load_chroot_env() { }
45load_target_env() { }
46buildenv_setup() { }
47
47# The directory within which the release will be built.
48CHROOTDIR="/scratch"
49RELENGDIR="$(realpath $(dirname $(basename ${0})))"
48usage() {
49 echo "Usage: $0 [-c release.conf]"
50 exit 1
51}
50
52
51# The default version control system command to obtain the sources.
52VCSCMD="svn checkout"
53# env_setup(): Set up the default build environment variables, such as the
54# CHROOTDIR, VCSCMD, SVNROOT, etc. This is called before the release.conf
55# file is sourced, if '-c <release.conf>' is specified.
56env_setup() {
57 # The directory within which the release will be built.
58 CHROOTDIR="/scratch"
59 RELENGDIR="$(dirname $(realpath ${0}))"
53
60
54# The default svn checkout server, and svn branches for src/, doc/,
55# and ports/.
56SVNROOT="svn://svn.FreeBSD.org/"
57SRCBRANCH="base/head@rHEAD"
58DOCBRANCH="doc/head@rHEAD"
59PORTBRANCH="ports/head@rHEAD"
61 # The default version control system command to obtain the sources.
62 for _dir in /usr/bin /usr/local/bin; do
63 for _svn in svn svnlite; do
64 [ -x "${_dir}/${_svn}" ] && VCSCMD="${_dir}/${_svn}"
65 [ ! -z "${VCSCMD}" ] && break 2
66 done
67 done
68 VCSCMD="${VCSCMD} checkout"
60
69
61# Set for embedded device builds.
62EMBEDDEDBUILD=
70 # The default svn checkout server, and svn branches for src/, doc/,
71 # and ports/.
72 SVNROOT="svn://svn.FreeBSD.org/"
73 SRCBRANCH="base/head@rHEAD"
74 DOCBRANCH="doc/head@rHEAD"
75 PORTBRANCH="ports/head@rHEAD"
63
76
64# Sometimes one needs to checkout src with --force svn option.
65# If custom kernel configs copied to src tree before checkout, e.g.
66SRC_FORCE_CHECKOUT=
77 # Set for embedded device builds.
78 EMBEDDEDBUILD=
67
79
68# The default make.conf and src.conf to use. Set to /dev/null
69# by default to avoid polluting the chroot(8) environment with
70# non-default settings.
71MAKE_CONF="/dev/null"
72SRC_CONF="/dev/null"
80 # Sometimes one needs to checkout src with --force svn option.
81 # If custom kernel configs copied to src tree before checkout, e.g.
82 SRC_FORCE_CHECKOUT=
73
83
74# The number of make(1) jobs, defaults to the number of CPUs available for
75# buildworld, and half of number of CPUs available for buildkernel.
76WORLD_FLAGS="-j$(sysctl -n hw.ncpu)"
77KERNEL_FLAGS="-j$(( $(( $(sysctl -n hw.ncpu) + 1 )) / 2))"
84 # The default make.conf and src.conf to use. Set to /dev/null
85 # by default to avoid polluting the chroot(8) environment with
86 # non-default settings.
87 MAKE_CONF="/dev/null"
88 SRC_CONF="/dev/null"
78
89
79MAKE_FLAGS="-s"
90 # The number of make(1) jobs, defaults to the number of CPUs available
91 # for buildworld, and half of number of CPUs available for buildkernel.
92 WORLD_FLAGS="-j$(sysctl -n hw.ncpu)"
93 KERNEL_FLAGS="-j$(( $(( $(sysctl -n hw.ncpu) + 1 )) / 2))"
80
94
81# The name of the kernel to build, defaults to GENERIC.
82KERNEL="GENERIC"
95 MAKE_FLAGS="-s"
83
96
84# Set to non-empty value to disable checkout of doc/ and/or ports/. Disabling
85# ports/ checkout also forces NODOC to be set.
86NODOC=
87NOPORTS=
97 # The name of the kernel to build, defaults to GENERIC.
98 KERNEL="GENERIC"
88
99
89# Set to non-empty value to build dvd1.iso as part of the release.
90WITH_DVD=
91WITH_COMPRESSED_IMAGES=
100 # Set to non-empty value to disable checkout of doc/ and/or ports/.
101 # Disabling ports/ checkout also forces NODOC to be set.
102 NODOC=
103 NOPORTS=
92
104
93# Set to non-empty value to build virtual machine images as part of
94# the release.
95WITH_VMIMAGES=
96WITH_COMPRESSED_VMIMAGES=
97XZ_THREADS=0
105 # Set to non-empty value to build dvd1.iso as part of the release.
106 WITH_DVD=
107 WITH_COMPRESSED_IMAGES=
98
108
99# Set to non-empty value to build virtual machine images for various
100# cloud providers as part of the release.
101WITH_CLOUDWARE=
109 # Set to non-empty value to build virtual machine images as part of
110 # the release.
111 WITH_VMIMAGES=
112 WITH_COMPRESSED_VMIMAGES=
113 XZ_THREADS=0
102
114
103usage() {
104 echo "Usage: $0 [-c release.conf]"
105 exit 1
106}
115 # Set to non-empty value to build virtual machine images for various
116 # cloud providers as part of the release.
117 WITH_CLOUDWARE=
107
118
108while getopts c: opt; do
109 case ${opt} in
110 c)
111 RELEASECONF="${OPTARG}"
112 if [ ! -e "${RELEASECONF}" ]; then
113 echo "ERROR: Configuration file ${RELEASECONF} does not exist."
114 exit 1
115 fi
116 # Source the specified configuration file for overrides
117 . ${RELEASECONF}
118 ;;
119 \?)
120 usage
121 ;;
119 return 0
120} # env_setup()
121
122# env_check(): Perform sanity tests on the build environment, such as ensuring
123# files/directories exist, as well as adding backwards-compatibility hacks if
124# necessary. This is called unconditionally, and overrides the defaults set
125# in env_setup() if '-c <release.conf>' is specified.
126env_check() {
127 chroot_build_release_cmd="chroot_build_release"
128 # Fix for backwards-compatibility with release.conf that does not have
129 # the trailing '/'.
130 case ${SVNROOT} in
131 *svn*)
132 SVNROOT="${SVNROOT}/"
133 ;;
134 *)
135 ;;
122 esac
136 esac
123done
124shift $(($OPTIND - 1))
125
137
126# Fix for backwards-compatibility with release.conf that does not have the
127# trailing '/'.
128case ${SVNROOT} in
129 *svn*)
130 SVNROOT="${SVNROOT}/"
131 ;;
132 *)
133 ;;
134esac
138 # Prefix the branches with the SVNROOT for the full checkout URL.
139 SRCBRANCH="${SVNROOT}${SRCBRANCH}"
140 DOCBRANCH="${SVNROOT}${DOCBRANCH}"
141 PORTBRANCH="${SVNROOT}${PORTBRANCH}"
135
142
136# Prefix the branches with the SVNROOT for the full checkout URL.
137SRCBRANCH="${SVNROOT}${SRCBRANCH}"
138DOCBRANCH="${SVNROOT}${DOCBRANCH}"
139PORTBRANCH="${SVNROOT}${PORTBRANCH}"
143 if [ -n "${EMBEDDEDBUILD}" ]; then
144 WITH_DVD=
145 WITH_COMPRESSED_IMAGES=
146 NODOC=yes
147 case ${EMBEDDED_TARGET}:${EMBEDDED_TARGET_ARCH} in
148 arm:armv6)
149 chroot_build_release_cmd="chroot_arm_armv6_build_release"
150 ;;
151 *)
152 esac
153 fi
140
154
141if [ -n "${EMBEDDEDBUILD}" ]; then
142 WITH_DVD=
143 WITH_COMPRESSED_IMAGES=
144 NODOC=yes
145fi
155 # If PORTS is set and NODOC is unset, force NODOC=yes because the ports
156 # tree is required to build the documentation set.
157 if [ -n "${NOPORTS}" ] && [ -z "${NODOC}" ]; then
158 echo "*** NOTICE: Setting NODOC=1 since ports tree is required"
159 echo " and NOPORTS is set."
160 NODOC=yes
161 fi
146
162
147# If PORTS is set and NODOC is unset, force NODOC=yes because the ports tree
148# is required to build the documentation set.
149if [ -n "${NOPORTS}" ] && [ -z "${NODOC}" ]; then
150 echo "*** NOTICE: Setting NODOC=1 since ports tree is required"
151 echo " and NOPORTS is set."
152 NODOC=yes
153fi
163 # If NOPORTS and/or NODOC are unset, they must not pass to make as
164 # variables. The release makefile verifies definedness of the
165 # NOPORTS/NODOC variables instead of their values.
166 DOCPORTS=
167 if [ -n "${NOPORTS}" ]; then
168 DOCPORTS="NOPORTS=yes "
169 fi
170 if [ -n "${NODOC}" ]; then
171 DOCPORTS="${DOCPORTS}NODOC=yes"
172 fi
154
173
155# If NOPORTS and/or NODOC are unset, they must not pass to make as variables.
156# The release makefile verifies definedness of NOPORTS/NODOC variables
157# instead of their values.
158DOCPORTS=
159if [ -n "${NOPORTS}" ]; then
160 DOCPORTS="NOPORTS=yes "
161fi
162if [ -n "${NODOC}" ]; then
163 DOCPORTS="${DOCPORTS}NODOC=yes"
164fi
174 # The aggregated build-time flags based upon variables defined within
175 # this file, unless overridden by release.conf. In most cases, these
176 # will not need to be changed.
177 CONF_FILES="__MAKE_CONF=${MAKE_CONF} SRCCONF=${SRC_CONF}"
178 if [ -n "${TARGET}" ] && [ -n "${TARGET_ARCH}" ]; then
179 ARCH_FLAGS="TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH}"
180 else
181 ARCH_FLAGS=
182 fi
183 # Force src checkout if configured
184 FORCE_SRC_KEY=
185 if [ -n "${SRC_FORCE_CHECKOUT}" ]; then
186 FORCE_SRC_KEY="--force"
187 fi
165
188
166# The aggregated build-time flags based upon variables defined within
167# this file, unless overridden by release.conf. In most cases, these
168# will not need to be changed.
169CONF_FILES="__MAKE_CONF=${MAKE_CONF} SRCCONF=${SRC_CONF}"
170if [ -n "${TARGET}" ] && [ -n "${TARGET_ARCH}" ]; then
171 ARCH_FLAGS="TARGET=${TARGET} TARGET_ARCH=${TARGET_ARCH}"
172else
173 ARCH_FLAGS=
174fi
175load_chroot_env
176CHROOT_MAKEENV="${CHROOT_MAKEENV} MAKEOBJDIRPREFIX=${CHROOTDIR}/tmp/obj"
177CHROOT_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${CONF_FILES}"
178CHROOT_IMAKEFLAGS="${CONF_FILES}"
179CHROOT_DMAKEFLAGS="${CONF_FILES}"
180RELEASE_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${ARCH_FLAGS} ${CONF_FILES}"
181RELEASE_KMAKEFLAGS="${MAKE_FLAGS} ${KERNEL_FLAGS} KERNCONF=\"${KERNEL}\" ${ARCH_FLAGS} ${CONF_FILES}"
182RELEASE_RMAKEFLAGS="${ARCH_FLAGS} KERNCONF=\"${KERNEL}\" ${CONF_FILES} \
183 ${DOCPORTS} WITH_DVD=${WITH_DVD} WITH_VMIMAGES=${WITH_VMIMAGES} \
184 WITH_CLOUDWARE=${WITH_CLOUDWARE} XZ_THREADS=${XZ_THREADS}"
189 if [ -z "${CHROOTDIR}" ]; then
190 echo "Please set CHROOTDIR."
191 exit 1
192 fi
185
193
186# Force src checkout if configured
187FORCE_SRC_KEY=
188if [ -n "${SRC_FORCE_CHECKOUT}" ]; then
189 FORCE_SRC_KEY="--force"
190fi
194 if [ $(id -u) -ne 0 ]; then
195 echo "Needs to be run as root."
196 exit 1
197 fi
191
198
192if [ -z "${CHROOTDIR}" ]; then
193 echo "Please set CHROOTDIR."
194 exit 1
195fi
199 CHROOT_MAKEENV="${CHROOT_MAKEENV} \
200 MAKEOBJDIRPREFIX=${CHROOTDIR}/tmp/obj"
201 CHROOT_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${CONF_FILES}"
202 CHROOT_IMAKEFLAGS="${CONF_FILES}"
203 CHROOT_DMAKEFLAGS="${CONF_FILES}"
204 RELEASE_WMAKEFLAGS="${MAKE_FLAGS} ${WORLD_FLAGS} ${ARCH_FLAGS} \
205 ${CONF_FILES}"
206 RELEASE_KMAKEFLAGS="${MAKE_FLAGS} ${KERNEL_FLAGS} \
207 KERNCONF=\"${KERNEL}\" ${ARCH_FLAGS} ${CONF_FILES}"
208 RELEASE_RMAKEFLAGS="${ARCH_FLAGS} \
209 KERNCONF=\"${KERNEL}\" ${CONF_FILES} ${DOCPORTS} \
210 WITH_DVD=${WITH_DVD} WITH_VMIMAGES=${WITH_VMIMAGES} \
211 WITH_CLOUDWARE=${WITH_CLOUDWARE} XZ_THREADS=${XZ_THREADS}"
196
212
197if [ $(id -u) -ne 0 ]; then
198 echo "Needs to be run as root."
199 exit 1
200fi
213 return 0
214} # env_check()
201
215
202set -e # Everything must succeed
216# chroot_setup(): Prepare the build chroot environment for the release build.
217chroot_setup() {
218 load_chroot_env
219 mkdir -p ${CHROOTDIR}/usr
203
220
204mkdir -p ${CHROOTDIR}/usr
221 if [ -z "${SRC_UPDATE_SKIP}" ]; then
222 ${VCSCMD} ${FORCE_SRC_KEY} ${SRCBRANCH} ${CHROOTDIR}/usr/src
223 fi
224 if [ -z "${NODOC}" ] && [ -z "${DOC_UPDATE_SKIP}" ]; then
225 ${VCSCMD} ${DOCBRANCH} ${CHROOTDIR}/usr/doc
226 fi
227 if [ -z "${NOPORTS}" ] && [ -z "${PORTS_UPDATE_SKIP}" ]; then
228 ${VCSCMD} ${PORTBRANCH} ${CHROOTDIR}/usr/ports
229 fi
205
230
206if [ -z "${SRC_UPDATE_SKIP}" ]; then
207 ${VCSCMD} ${FORCE_SRC_KEY} ${SRCBRANCH} ${CHROOTDIR}/usr/src
208fi
209if [ -z "${NODOC}" ] && [ -z "${DOC_UPDATE_SKIP}" ]; then
210 ${VCSCMD} ${DOCBRANCH} ${CHROOTDIR}/usr/doc
211fi
212if [ -z "${NOPORTS}" ] && [ -z "${PORTS_UPDATE_SKIP}" ]; then
213 ${VCSCMD} ${PORTBRANCH} ${CHROOTDIR}/usr/ports
214fi
231 if [ -z "${CHROOTBUILD_SKIP}" ]; then
232 cd ${CHROOTDIR}/usr/src
233 env ${CHROOT_MAKEENV} make ${CHROOT_WMAKEFLAGS} buildworld
234 env ${CHROOT_MAKEENV} make ${CHROOT_IMAKEFLAGS} installworld \
235 DESTDIR=${CHROOTDIR}
236 env ${CHROOT_MAKEENV} make ${CHROOT_DMAKEFLAGS} distribution \
237 DESTDIR=${CHROOTDIR}
238 fi
215
239
216if [ -z "${CHROOTBUILD_SKIP}" ]; then
217 cd ${CHROOTDIR}/usr/src
218 env ${CHROOT_MAKEENV} make ${CHROOT_WMAKEFLAGS} buildworld
219 env ${CHROOT_MAKEENV} make ${CHROOT_IMAKEFLAGS} installworld \
220 DESTDIR=${CHROOTDIR}
221 env ${CHROOT_MAKEENV} make ${CHROOT_DMAKEFLAGS} distribution \
222 DESTDIR=${CHROOTDIR}
223fi
224mount -t devfs devfs ${CHROOTDIR}/dev
225cp /etc/resolv.conf ${CHROOTDIR}/etc/resolv.conf
226trap "umount ${CHROOTDIR}/dev" EXIT # Clean up devfs mount on exit
240 return 0
241} # chroot_setup()
227
242
228# If MAKE_CONF and/or SRC_CONF are set and not character devices (/dev/null),
229# copy them to the chroot.
230if [ -e ${MAKE_CONF} ] && [ ! -c ${MAKE_CONF} ]; then
231 mkdir -p ${CHROOTDIR}/$(dirname ${MAKE_CONF})
232 cp ${MAKE_CONF} ${CHROOTDIR}/${MAKE_CONF}
233fi
234if [ -e ${SRC_CONF} ] && [ ! -c ${SRC_CONF} ]; then
235 mkdir -p ${CHROOTDIR}/$(dirname ${SRC_CONF})
236 cp ${SRC_CONF} ${CHROOTDIR}/${SRC_CONF}
237fi
243# extra_chroot_setup(): Prepare anything additional within the build
244# necessary for the release build.
245extra_chroot_setup() {
246 mkdir -p ${CHROOTDIR}/dev
247 mount -t devfs devfs ${CHROOTDIR}/dev
248 [ -e /etc/resolv.conf ] && cp /etc/resolv.conf \
249 ${CHROOTDIR}/etc/resolv.conf
250 # Run ldconfig(8) in the chroot directory so /var/run/ld-elf*.so.hints
251 # is created. This is needed by ports-mgmt/pkg.
252 eval chroot ${CHROOTDIR} /etc/rc.d/ldconfig forcerestart
238
253
239# Embedded builds do not use the 'make release' target.
240if [ -n "${EMBEDDEDBUILD}" ]; then
254 # If MAKE_CONF and/or SRC_CONF are set and not character devices
255 # (/dev/null), copy them to the chroot.
256 if [ -e ${MAKE_CONF} ] && [ ! -c ${MAKE_CONF} ]; then
257 mkdir -p ${CHROOTDIR}/$(dirname ${MAKE_CONF})
258 cp ${MAKE_CONF} ${CHROOTDIR}/${MAKE_CONF}
259 fi
260 if [ -e ${SRC_CONF} ] && [ ! -c ${SRC_CONF} ]; then
261 mkdir -p ${CHROOTDIR}/$(dirname ${SRC_CONF})
262 cp ${SRC_CONF} ${CHROOTDIR}/${SRC_CONF}
263 fi
264
265 if [ -d ${CHROOTDIR}/usr/ports ]; then
266 # Trick the ports 'run-autotools-fixup' target to do the right
267 # thing.
268 _OSVERSION=$(chroot ${CHROOTDIR} /usr/bin/uname -U)
269 REVISION=$(chroot ${CHROOTDIR} make -C /usr/src/release -V REVISION)
270 BRANCH=$(chroot ${CHROOTDIR} make -C /usr/src/release -V BRANCH)
271 UNAME_r=${REVISION}-${BRANCH}
272 if [ -d ${CHROOTDIR}/usr/doc ] && [ -z "${NODOC}" ]; then
273 PBUILD_FLAGS="OSVERSION=${_OSVERSION} BATCH=yes"
274 PBUILD_FLAGS="${PBUILD_FLAGS} UNAME_r=${UNAME_r}"
275 PBUILD_FLAGS="${PBUILD_FLAGS} OSREL=${REVISION}"
276 chroot ${CHROOTDIR} make -C /usr/ports/textproc/docproj \
277 ${PBUILD_FLAGS} OPTIONS_UNSET="FOP IGOR" \
278 install clean distclean
279 fi
280 fi
281
282 if [ ! -z "${EMBEDDEDPORTS}" ]; then
283 for _PORT in ${EMBEDDEDPORTS}; do
284 eval chroot ${CHROOTDIR} make -C /usr/ports/${_PORT} \
285 BATCH=1 FORCE_PKG_REGISTER=1 install clean distclean
286 done
287 fi
288
241 buildenv_setup
289 buildenv_setup
242 # If a crochet configuration file exists in *this* checkout of
243 # release/, copy it to the /tmp/external directory within the chroot.
244 # This allows building embedded releases without relying on updated
245 # scripts and/or configurations to exist in the branch being built.
290
291 return 0
292} # extra_chroot_setup()
293
294# chroot_build_target(): Build the userland and kernel for the build target.
295chroot_build_target() {
246 load_target_env
296 load_target_env
247 if [ -e ${RELENGDIR}/tools/${XDEV}/crochet-${KERNEL}.conf ] && \
248 [ -e ${RELENGDIR}/${XDEV}/release.sh ]; then
249 mkdir -p ${CHROOTDIR}/tmp/external/${XDEV}/
250 cp ${RELENGDIR}/tools/${XDEV}/crochet-${KERNEL}.conf \
251 ${CHROOTDIR}/tmp/external/${XDEV}/crochet-${KERNEL}.conf
252 /bin/sh ${RELENGDIR}/${XDEV}/release.sh
297 if [ ! -z "${EMBEDDEDBUILD}" ]; then
298 RELEASE_WMAKEFLAGS="${RELEASE_WMAKEFLAGS} \
299 TARGET=${EMBEDDED_TARGET} \
300 TARGET_ARCH=${EMBEDDED_TARGET_ARCH}"
301 RELEASE_KMAKEFLAGS="${RELEASE_KMAKEFLAGS} \
302 TARGET=${EMBEDDED_TARGET} \
303 TARGET_ARCH=${EMBEDDED_TARGET_ARCH}"
253 fi
304 fi
254 # If the script does not exist for this architecture, exit.
255 # This probably should be checked earlier, but allowing the rest
256 # of the build process to get this far will at least set up the
257 # chroot environment for testing.
258 exit 0
259else
260 # Not embedded.
261 continue
262fi
305 eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_WMAKEFLAGS} buildworld
306 eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_KMAKEFLAGS} buildkernel
263
307
264if [ -d ${CHROOTDIR}/usr/ports ]; then
265 # Run ldconfig(8) in the chroot directory so /var/run/ld-elf*.so.hints
266 # is created. This is needed by ports-mgmt/pkg.
267 chroot ${CHROOTDIR} /etc/rc.d/ldconfig forcerestart
308 return 0
309} # chroot_build_target
268
310
269 ## Trick the ports 'run-autotools-fixup' target to do the right thing.
270 _OSVERSION=$(sysctl -n kern.osreldate)
271 REVISION=$(chroot ${CHROOTDIR} make -C /usr/src/release -V REVISION)
272 BRANCH=$(chroot ${CHROOTDIR} make -C /usr/src/release -V BRANCH)
273 UNAME_r=${REVISION}-${BRANCH}
274 if [ -d ${CHROOTDIR}/usr/doc ] && [ -z "${NODOC}" ]; then
275 PBUILD_FLAGS="OSVERSION=${_OSVERSION} BATCH=yes"
276 PBUILD_FLAGS="${PBUILD_FLAGS} UNAME_r=${UNAME_r}"
277 PBUILD_FLAGS="${PBUILD_FLAGS} OSREL=${REVISION}"
278 chroot ${CHROOTDIR} make -C /usr/ports/textproc/docproj \
279 ${PBUILD_FLAGS} OPTIONS_UNSET="FOP IGOR" \
280 install clean distclean
311# chroot_build_release(): Invoke the 'make release' target.
312chroot_build_release() {
313 load_target_env
314 eval chroot ${CHROOTDIR} make -C /usr/src/release \
315 ${RELEASE_RMAKEFLAGS} release
316 eval chroot ${CHROOTDIR} make -C /usr/src/release \
317 ${RELEASE_RMAKEFLAGS} install DESTDIR=/R \
318 WITH_COMPRESSED_IMAGES=${WITH_COMPRESSED_IMAGES} \
319 WITH_COMPRESSED_VMIMAGES=${WITH_COMPRESSED_VMIMAGES}
320
321 return 0
322} # chroot_build_release()
323
324# chroot_arm_armv6_build_release(): Create arm/armv6 SD card image.
325chroot_arm_armv6_build_release() {
326 load_target_env
327 eval chroot ${CHROOTDIR} make -C /usr/src/release obj
328 if [ -e "${RELENGDIR}/tools/${EMBEDDED_TARGET}.subr" ]; then
329 . "${RELENGDIR}/tools/${EMBEDDED_TARGET}.subr"
281 fi
330 fi
282fi
331 [ ! -z "${RELEASECONF}" ] && . "${RELEASECONF}"
332 WORLDDIR="$(eval chroot ${CHROOTDIR} make -C /usr/src/release -V WORLDDIR)"
333 OBJDIR="$(eval chroot ${CHROOTDIR} make -C /usr/src/release -V .OBJDIR)"
334 DESTDIR="${OBJDIR}/${KERNEL}"
335 IMGBASE="${CHROOTDIR}/${OBJDIR}/${KERNEL}.img"
336 OSRELEASE="$(eval chroot ${CHROOTDIR} make -C /usr/src/release \
337 TARGET=${EMBEDDED_TARGET} TARGET_ARCH=${EMBEDDED_TARGET_ARCH} \
338 -V OSRELEASE)"
339 chroot ${CHROOTDIR} mkdir -p ${DESTDIR}
340 chroot ${CHROOTDIR} truncate -s ${IMAGE_SIZE} ${IMGBASE##${CHROOTDIR}}
341 export mddev=$(chroot ${CHROOTDIR} \
342 mdconfig -f ${IMGBASE##${CHROOTDIR}} ${MD_ARGS})
343 arm_create_disk
344 arm_install_base
345 arm_install_uboot
346 mdconfig -d -u ${mddev}
347 chroot ${CHROOTDIR} rmdir ${DESTDIR}
348 mv ${IMGBASE} ${CHROOTDIR}/${OBJDIR}/${OSRELEASE}-${KERNEL}.img
349 chroot ${CHROOTDIR} mkdir -p /R
350 chroot ${CHROOTDIR} cp -p ${OBJDIR}/${OSRELEASE}-${KERNEL}.img \
351 /R/${OSRELEASE}-${KERNEL}.img
352 chroot ${CHROOTDIR} xz -T ${XZ_THREADS} /R/${OSRELEASE}-${KERNEL}.img
353 cd ${CHROOTDIR}/R && sha256 ${OSRELEASE}* \
354 > CHECKSUM.SHA256
355 cd ${CHROOTDIR}/R && md5 ${OSRELEASE}* \
356 > CHECKSUM.MD5
283
357
284buildenv_setup
285load_target_env
286eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_WMAKEFLAGS} buildworld
287eval chroot ${CHROOTDIR} make -C /usr/src ${RELEASE_KMAKEFLAGS} buildkernel
288eval chroot ${CHROOTDIR} make -C /usr/src/release ${RELEASE_RMAKEFLAGS} \
289 release
290eval chroot ${CHROOTDIR} make -C /usr/src/release ${RELEASE_RMAKEFLAGS} \
291 install DESTDIR=/R WITH_COMPRESSED_IMAGES=${WITH_COMPRESSED_IMAGES} \
292 WITH_COMPRESSED_VMIMAGES=${WITH_COMPRESSED_VMIMAGES}
358 return 0
359} # chroot_arm_armv6_build_release()
360
361# main(): Start here.
362main() {
363 set -e # Everything must succeed
364 env_setup
365 while getopts c: opt; do
366 case ${opt} in
367 c)
368 RELEASECONF="${OPTARG}"
369 ;;
370 \?)
371 usage
372 ;;
373 esac
374 done
375 shift $(($OPTIND - 1))
376 if [ ! -z "${RELEASECONF}" ]; then
377 if [ -e "${RELEASECONF}" ]; then
378 . ${RELEASECONF}
379 else
380 echo "Nonexistent configuration file: ${RELEASECONF}"
381 echo "Using default build environment."
382 fi
383 fi
384 env_check
385 trap "umount ${CHROOTDIR}/dev" EXIT # Clean up devfs mount on exit
386 chroot_setup
387 extra_chroot_setup
388 chroot_build_target
389 ${chroot_build_release_cmd}
390
391 return 0
392} # main()
393
394main "${@}"